// import axios from "axios"
// import { useEffect, useState } from "react"
// import { useParams } from "react-router-dom"

// export default function CallPage() {
//     const [isLoading, setIsLoading] = useState(true)
//     const [error, setError] = useState(false)
//     const [callData, setCallData] = useState<any>(null)

//     const {callId} = useParams()

//     async function fetchCallData() {
//         try {
//             setIsLoading(true)
//             const response = await axios.get(`${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`, {
//                 headers: {
//                     Authorization: localStorage.getItem('token') as string
//                 }
//             })

//             setError(false)
//             setCallData(response.data)
//         } catch (error) {
//             console.log(error)
//             setError(true)
//         } finally {
//             setIsLoading(false)
//         }
//     }

//     useEffect(() => {
//         fetchCallData()
//     }, [])

//     if (isLoading){
//         return <div> Loading ...</div>
//     }

//     return (
//         <div>Call Id: {callData.call_id}</div>
//     )
// }

// import axios from "axios";
// import { useEffect, useState, useRef } from "react";
// import { useParams } from "react-router-dom";
// import { format } from "date-fns";
// import {
//   Card,
//   CardContent,
//   CardDescription,
//   CardHeader,
//   CardTitle
// } from "@/components/ui/card";
// import { Avatar, AvatarFallback } from "@/components/ui/avatar";
// import { Badge } from "@/components/ui/badge";
// import { Separator } from "@/components/ui/separator";
// import {
//   PhoneCall,
//   Clock,
//   Calendar,
//   User,
//   MessageSquare,
//   Play,
//   Pause,
//   SkipBack,
//   SkipForward,
//   Volume2,
//   AlignJustify,
//   Phone
// } from "lucide-react";
// import { Skeleton } from "@/components/ui/skeleton";
// import { Slider } from "@/components/ui/slider";
// import { Button } from "@/components/ui/button";
// import { Alert, AlertDescription, AlertTitle } from "@/components/ui/alert";

// // Types for our data
// interface Message {
//   role: string;
//   time: number;
//   endTime: number;
//   message: string;
//   duration: number;
//   secondsFromStart: number;
//   source?: string;
// }

// interface CallData {
//   call_id: string;
//   call_started_at: string;
//   call_type: string;
//   call_ended_at: string;
//   recording_url: string;
//   customer_phone: string;
//   call_status: string;
//   call_end_reason: string;
//   messages: Message[];
// }

// export default function CallPage() {
//   const [isLoading, setIsLoading] = useState(true);
//   const [error, setError] = useState(false);
//   const [callData, setCallData] = useState<CallData | null>(null);
//   const { callId } = useParams();

//   // Audio player states
//   const audioRef = useRef<HTMLAudioElement | null>(null);
//   const [isPlaying, setIsPlaying] = useState(false);
//   const [currentTime, setCurrentTime] = useState(0);
//   const [duration, setDuration] = useState(0);
//   const [volume, setVolume] = useState(1);

//   async function fetchCallData() {
//     try {
//       setIsLoading(true);
//       const response = await axios.get(`${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`, {
//         headers: {
//           Authorization: localStorage.getItem('token') as string
//         }
//       });
//       setError(false);
//       setCallData(response.data);
//     } catch (error) {
//       console.log(error);
//       setError(true);
//     } finally {
//       setIsLoading(false);
//     }
//   }

//   useEffect(() => {
//     fetchCallData();
//   }, [callId]);

//   // Audio player controls
//   useEffect(() => {
//     const audio = audioRef.current;
//     if (!audio) return;

//     const updateTime = () => setCurrentTime(audio.currentTime);
//     const updateDuration = () => setDuration(audio.duration);
//     const handleEnded = () => setIsPlaying(false);

//     audio.addEventListener('timeupdate', updateTime);
//     audio.addEventListener('durationchange', updateDuration);
//     audio.addEventListener('ended', handleEnded);

//     return () => {
//       audio.removeEventListener('timeupdate', updateTime);
//       audio.removeEventListener('durationchange', updateDuration);
//       audio.removeEventListener('ended', handleEnded);
//     };
//   }, [audioRef.current]);

//   const togglePlayPause = () => {
//     if (!audioRef.current) return;

//     if (isPlaying) {
//       audioRef.current.pause();
//     } else {
//       audioRef.current.play();
//     }

//     setIsPlaying(!isPlaying);
//   };

//   const handleSeek = (value: number[]) => {
//     if (!audioRef.current) return;

//     const seekTime = value[0];
//     audioRef.current.currentTime = seekTime;
//     setCurrentTime(seekTime);
//   };

//   const handleVolumeChange = (value: number[]) => {
//     if (!audioRef.current) return;

//     const newVolume = value[0];
//     audioRef.current.volume = newVolume;
//     setVolume(newVolume);
//   };

//   const skipBackward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.max(0, audioRef.current.currentTime - 10);
//   };

//   const skipForward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.min(duration, audioRef.current.currentTime + 10);
//   };

//   const formatTime = (time: number) => {
//     const minutes = Math.floor(time / 60);
//     const seconds = Math.floor(time % 60);
//     return `${minutes}:${seconds.toString().padStart(2, '0')}`;
//   };

//   const formatDate = (dateString: string) => {
//     return format(new Date(dateString), "MMM d, yyyy 'at' h:mm a");
//   };

//   const formatMessageTime = (timestamp: number) => {
//     return format(new Date(timestamp), "h:mm:ss a");
//   };

//   const getCallTypeLabel = (type: string) => {
//     switch (type) {
//       case "inboundPhoneCall":
//         return "Inbound Phone Call";
//       case "outboundPhoneCall":
//         return "Outbound Phone Call";
//       default:
//         return type.replace(/([A-Z])/g, ' $1').trim();
//     }
//   };

//   const getStatusColor = (status: string) => {
//     switch (status) {
//       case "ended":
//         return "bg-green-100 text-green-800";
//       case "in-progress":
//         return "bg-blue-100 text-blue-800";
//       case "missed":
//         return "bg-red-100 text-red-800";
//       default:
//         return "bg-gray-100 text-gray-800";
//     }
//   };

//   const calculateCallDuration = (start: string, end: string) => {
//     const startTime = new Date(start).getTime();
//     const endTime = new Date(end).getTime();
//     const durationInSeconds = (endTime - startTime) / 1000;

//     const minutes = Math.floor(durationInSeconds / 60);
//     const seconds = Math.floor(durationInSeconds % 60);

//     return `${minutes}m ${seconds}s`;
//   };

//   if (isLoading) {
//     return (
//       <div className="container mx-auto px-4 py-8">
//         <div className="space-y-6">
//           <Skeleton className="h-12 w-full rounded-lg" />
//           <div className="grid gap-6 md:grid-cols-2">
//             <Skeleton className="h-64 rounded-lg" />
//             <Skeleton className="h-64 rounded-lg" />
//           </div>
//           <Skeleton className="h-96 rounded-lg" />
//         </div>
//       </div>
//     );
//   }

//   if (error || !callData) {
//     return (
//       <div className="container mx-auto px-4 py-8">
//         <Alert variant="destructive">
//           <AlertTitle>Error</AlertTitle>
//           <AlertDescription>Failed to load call data. Please try again later.</AlertDescription>
//         </Alert>
//         <Button
//           className="mt-4"
//           onClick={fetchCallData}
//         >
//           Retry
//         </Button>
//       </div>
//     );
//   }

//   return (
//     <div className="container mx-auto px-4 py-8">
//       {/* Page Header */}
//       <div className="mb-6 flex flex-col md:flex-row justify-between items-start md:items-center">
//         <div>
//           <h1 className="text-2xl font-bold flex items-center gap-2">
//             <PhoneCall className="h-6 w-6" />
//             Call Details
//           </h1>
//           <p className="text-muted-foreground mt-1">
//             ID: {callData.call_id}
//           </p>
//         </div>
//         <Badge
//           className={`mt-2 md:mt-0 ${getStatusColor(callData.call_status)}`}
//         >
//           {callData.call_status.charAt(0).toUpperCase() + callData.call_status.slice(1)}
//         </Badge>
//       </div>

//       {/* Main Content Grid */}
//       <div className="grid gap-6 md:grid-cols-2 lg:grid-cols-3">
//         {/* Call Details Card */}
//         <Card className="lg:col-span-1">
//           <CardHeader>
//             <CardTitle className="flex items-center gap-2">
//               <AlignJustify className="h-5 w-5" />
//               Call Information
//             </CardTitle>
//           </CardHeader>
//           <CardContent className="space-y-4">
//             <div className="flex items-start gap-3">
//               <Calendar className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">Start Time</p>
//                 <p className="text-sm text-muted-foreground">
//                   {formatDate(callData.call_started_at)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <Calendar className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">End Time</p>
//                 <p className="text-sm text-muted-foreground">
//                   {formatDate(callData.call_ended_at)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <Clock className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">Duration</p>
//                 <p className="text-sm text-muted-foreground">
//                   {calculateCallDuration(callData.call_started_at, callData.call_ended_at)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <Phone className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">Call Type</p>
//                 <p className="text-sm text-muted-foreground">
//                   {getCallTypeLabel(callData.call_type)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <User className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">Customer Phone</p>
//                 <p className="text-sm text-muted-foreground">
//                   {callData.customer_phone}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <MessageSquare className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">End Reason</p>
//                 <p className="text-sm text-muted-foreground">
//                   {callData.call_end_reason.replace(/-/g, ' ').replace(/\b\w/g, l => l.toUpperCase())}
//                 </p>
//               </div>
//             </div>
//           </CardContent>
//         </Card>

//         {/* Audio Player Card */}
//         <Card className="lg:col-span-2">
//           <CardHeader>
//             <CardTitle className="flex items-center gap-2">
//               <Volume2 className="h-5 w-5" />
//               Call Recording
//             </CardTitle>
//             <CardDescription>
//               Listen to the recorded conversation
//             </CardDescription>
//           </CardHeader>
//           <CardContent>
//             <audio
//               ref={audioRef}
//               src={callData.recording_url}
//               className="hidden"
//             />

//             <div className="space-y-4">
//               <div className="flex items-center justify-between">
//                 <span className="text-sm text-muted-foreground">
//                   {formatTime(currentTime)}
//                 </span>
//                 <span className="text-sm text-muted-foreground">
//                   {formatTime(duration)}
//                 </span>
//               </div>

//               <Slider
//                 value={[currentTime]}
//                 max={duration || 100}
//                 step={0.1}
//                 onValueChange={handleSeek}
//                 className="w-full"
//               />

//               <div className="flex justify-center items-center gap-4">
//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipBackward}
//                   title="Rewind 10 seconds"
//                 >
//                   <SkipBack className="h-5 w-5" />
//                 </Button>

//                 <Button
//                   variant="outline"
//                   size="icon"
//                   className="h-12 w-12"
//                   onClick={togglePlayPause}
//                 >
//                   {isPlaying ? (
//                     <Pause className="h-6 w-6" />
//                   ) : (
//                     <Play className="h-6 w-6" />
//                   )}
//                 </Button>

//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipForward}
//                   title="Forward 10 seconds"
//                 >
//                   <SkipForward className="h-5 w-5" />
//                 </Button>
//               </div>

//               <div className="flex items-center gap-2">
//                 <Volume2 className="h-4 w-4 text-muted-foreground" />
//                 <Slider
//                   value={[volume]}
//                   max={1}
//                   step={0.01}
//                   onValueChange={handleVolumeChange}
//                   className="w-24"
//                 />
//               </div>
//             </div>
//           </CardContent>
//         </Card>
//       </div>

//       {/* Transcript Section */}
//       <Card className="mt-6">
//         <CardHeader>
//           <CardTitle className="flex items-center gap-2">
//             <MessageSquare className="h-5 w-5" />
//             Conversation Transcript
//           </CardTitle>
//           <CardDescription>
//             Complete transcript of the conversation between the bot and the user
//           </CardDescription>
//         </CardHeader>
//         <CardContent>
//           <div className="space-y-4">
//             {callData.messages.map((message, index) => (
//               <div
//                 key={index}
//                 className={`flex gap-4 ${message.role === 'bot' ? 'justify-start' : 'justify-end'}`}
//               >
//                 {message.role === 'bot' && (
//                   <Avatar>
//                     <AvatarFallback className="bg-primary/10 text-primary">
//                       B
//                     </AvatarFallback>
//                   </Avatar>
//                 )}

//                 <div className={`flex flex-col max-w-[80%] ${message.role === 'bot' ? 'items-start' : 'items-end'}`}>
//                   <div
//                     className={`px-4 py-3 rounded-lg ${
//                       message.role === 'bot'
//                         ? 'bg-muted text-foreground rounded-tl-none'
//                         : 'bg-primary text-primary-foreground rounded-tr-none'
//                     }`}
//                   >
//                     {message.message}
//                   </div>
//                   <span className="text-xs text-muted-foreground mt-1">
//                     {formatMessageTime(message.time)} • {(message.duration / 1000).toFixed(1)}s
//                   </span>
//                 </div>

//                 {message.role === 'user' && (
//                   <Avatar>
//                     <AvatarFallback className="bg-primary text-primary-foreground">
//                       U
//                     </AvatarFallback>
//                   </Avatar>
//                 )}
//               </div>
//             ))}
//           </div>
//         </CardContent>
//       </Card>
//     </div>
//   );
// }

// import axios from "axios";
// import { useEffect, useState, useRef } from "react";
// import { useParams } from "react-router-dom";
// import { format } from "date-fns";
// import {
//   Card,
//   CardContent,
//   CardDescription,
//   CardHeader,
//   CardTitle
// } from "@/components/ui/card";
// import { Avatar, AvatarFallback } from "@/components/ui/avatar";
// import { Badge } from "@/components/ui/badge";
// import { Separator } from "@/components/ui/separator";
// import {
//   PhoneCall,
//   Clock,
//   Calendar,
//   User,
//   MessageSquare,
//   Play,
//   Pause,
//   SkipBack,
//   SkipForward,
//   Volume2,
//   AlignJustify,
//   Phone,
//   Globe
// } from "lucide-react";
// import { Skeleton } from "@/components/ui/skeleton";
// import { Slider } from "@/components/ui/slider";
// import { Button } from "@/components/ui/button";
// import { Alert, AlertDescription, AlertTitle } from "@/components/ui/alert";

// // Types for our data
// interface Message {
//   role: string;
//   time: number;
//   endTime: number;
//   message: string;
//   duration: number;
//   secondsFromStart: number;
//   source?: string;
// }

// interface CallData {
//   call_id: string;
//   call_started_at: string;
//   call_type: string;
//   call_ended_at: string;
//   recording_url: string;
//   customer_phone?: string; // Making this optional
//   call_status: string;
//   call_end_reason: string;
//   messages: Message[];
// }

// export default function CallPage() {
//   const [isLoading, setIsLoading] = useState(true);
//   const [error, setError] = useState(false);
//   const [callData, setCallData] = useState<CallData | null>(null);
//   const { callId } = useParams();

//   // Audio player states
//   const audioRef = useRef<HTMLAudioElement | null>(null);
//   const [isPlaying, setIsPlaying] = useState(false);
//   const [currentTime, setCurrentTime] = useState(0);
//   const [duration, setDuration] = useState(0);
//   const [volume, setVolume] = useState(1);

//   async function fetchCallData() {
//     try {
//       setIsLoading(true);
//       const response = await axios.get(`${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`, {
//         headers: {
//           Authorization: localStorage.getItem('token') as string
//         }
//       });
//       setError(false);
//       setCallData(response.data);
//     } catch (error) {
//       console.log(error);
//       setError(true);
//     } finally {
//       setIsLoading(false);
//     }
//   }

//   useEffect(() => {
//     fetchCallData();
//   }, [callId]);

//   // Audio player controls
//   useEffect(() => {
//     const audio = audioRef.current;
//     if (!audio) return;

//     const updateTime = () => setCurrentTime(audio.currentTime);
//     const updateDuration = () => {
//       if (audio.duration && !isNaN(audio.duration)) {
//         setDuration(audio.duration);
//       } else {
//         // Fallback to calculated duration if audio.duration is not available
//         if (callData) {
//           setDuration(calculateCallDurationInSeconds(callData.call_started_at, callData.call_ended_at));
//         }
//       }
//     };
//     const handleEnded = () => setIsPlaying(false);

//     audio.addEventListener('timeupdate', updateTime);
//     audio.addEventListener('durationchange', updateDuration);
//     audio.addEventListener('ended', handleEnded);

//     // Set initial duration when component mounts
//     if (callData) {
//       if (audio.duration && !isNaN(audio.duration)) {
//         setDuration(audio.duration);
//       } else {
//         setDuration(calculateCallDurationInSeconds(callData.call_started_at, callData.call_ended_at));
//       }
//     }

//     return () => {
//       audio.removeEventListener('timeupdate', updateTime);
//       audio.removeEventListener('durationchange', updateDuration);
//       audio.removeEventListener('ended', handleEnded);
//     };
//   }, [audioRef.current, callData]);

//   const togglePlayPause = () => {
//     if (!audioRef.current) return;

//     if (isPlaying) {
//       audioRef.current.pause();
//     } else {
//       audioRef.current.play();
//     }

//     setIsPlaying(!isPlaying);
//   };

//   const handleSeek = (value: number[]) => {
//     if (!audioRef.current) return;

//     const seekTime = value[0];
//     audioRef.current.currentTime = seekTime;
//     setCurrentTime(seekTime);
//   };

//   const handleVolumeChange = (value: number[]) => {
//     if (!audioRef.current) return;

//     const newVolume = value[0];
//     audioRef.current.volume = newVolume;
//     setVolume(newVolume);
//   };

//   const skipBackward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.max(0, audioRef.current.currentTime - 10);
//   };

//   const skipForward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.min(duration, audioRef.current.currentTime + 10);
//   };

//   const formatTime = (time: number) => {
//     const minutes = Math.floor(time / 60);
//     const seconds = Math.floor(time % 60);
//     return `${minutes}:${seconds.toString().padStart(2, '0')}`;
//   };

//   const formatDate = (dateString: string) => {
//     return format(new Date(dateString), "MMM d, yyyy 'at' h:mm a");
//   };

//   const formatMessageTime = (timestamp: number) => {
//     return format(new Date(timestamp), "h:mm:ss a");
//   };

//   const getCallTypeLabel = (type: string) => {
//     switch (type) {
//       case "inboundPhoneCall":
//         return "Inbound Phone Call";
//       case "outboundPhoneCall":
//         return "Outbound Phone Call";
//       case "webCall":
//         return "Web Call";
//       default:
//         return type.replace(/([A-Z])/g, ' $1').trim();
//     }
//   };

//   const getCallTypeIcon = (type: string) => {
//     if (type.includes("PhoneCall")) {
//       return <Phone className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />;
//     } else if (type === "webCall") {
//       return <Globe className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />;
//     } else {
//       return <MessageSquare className="h-5 w-5 text-muted-foreground shrink-0 mt-0.5" />;
//     }
//   };

//   const getStatusColor = (status: string) => {
//     switch (status) {
//       case "ended":
//         return "bg-emerald-100 text-emerald-800 border-emerald-200";
//       case "in-progress":
//         return "bg-blue-100 text-blue-800 border-blue-200";
//       case "missed":
//         return "bg-red-100 text-red-800 border-red-200";
//       default:
//         return "bg-gray-100 text-gray-800 border-gray-200";
//     }
//   };

//   const calculateCallDuration = (start: string, end: string) => {
//     const durationInSeconds = calculateCallDurationInSeconds(start, end);

//     const minutes = Math.floor(durationInSeconds / 60);
//     const seconds = Math.floor(durationInSeconds % 60);

//     return `${minutes}m ${seconds}s`;
//   };

//   const calculateCallDurationInSeconds = (start: string, end: string) => {
//     const startTime = new Date(start).getTime();
//     const endTime = new Date(end).getTime();
//     return (endTime - startTime) / 1000;
//   };

//   if (isLoading) {
//     return (
//       <div className="container mx-auto px-4 py-8">
//         <div className="space-y-6">
//           <Skeleton className="h-12 w-full rounded-lg" />
//           <div className="grid gap-6 md:grid-cols-2">
//             <Skeleton className="h-64 rounded-lg" />
//             <Skeleton className="h-64 rounded-lg" />
//           </div>
//           <Skeleton className="h-96 rounded-lg" />
//         </div>
//       </div>
//     );
//   }

//   if (error || !callData) {
//     return (
//       <div className="container mx-auto px-4 py-8">
//         <Alert variant="destructive">
//           <AlertTitle>Error</AlertTitle>
//           <AlertDescription>Failed to load call data. Please try again later.</AlertDescription>
//         </Alert>
//         <Button
//           className="mt-4"
//           onClick={fetchCallData}
//         >
//           Retry
//         </Button>
//       </div>
//     );
//   }

//   return (
//     <div className="container mx-auto px-4 py-8">
//       {/* Page Header */}
//       <div className="mb-6 flex flex-col md:flex-row justify-between items-start md:items-center">
//         <div>
//           <h1 className="text-2xl font-bold flex items-center gap-2">
//             <PhoneCall className="h-6 w-6" />
//             Call Details
//           </h1>
//           <p className="text-muted-foreground mt-1">
//             ID: <span className="font-mono text-gray-600">{callData.call_id}</span>
//           </p>
//         </div>
//         <Badge
//           className={`mt-2 md:mt-0 border px-3 py-1 ${getStatusColor(callData.call_status)}`}
//         >
//           {callData.call_status.charAt(0).toUpperCase() + callData.call_status.slice(1)}
//         </Badge>
//       </div>

//       {/* Main Content Grid */}
//       <div className="grid gap-6 md:grid-cols-2 lg:grid-cols-3">
//         {/* Call Details Card */}
//         <Card className="lg:col-span-1 border-indigo-100 shadow-sm">
//           <CardHeader className="border-b border-indigo-50 bg-indigo-50/30">
//             <CardTitle className="flex items-center gap-2 text-indigo-700">
//               <AlignJustify className="h-5 w-5 text-indigo-500" />
//               Call Information
//             </CardTitle>
//           </CardHeader>
//           <CardContent className="space-y-4 pt-6">
//             <div className="flex items-start gap-3">
//               <Calendar className="h-5 w-5 shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium">Start Time</p>
//                 <p className="text-sm text-gray-600">
//                   {formatDate(callData.call_started_at)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <Calendar className="h-5 w-5 shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium ">End Time</p>
//                 <p className="text-sm text-gray-600">
//                   {formatDate(callData.call_ended_at)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               <Clock className="h-5 w-5 shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium ">Duration</p>
//                 <p className="text-sm text-gray-600">
//                   {calculateCallDuration(callData.call_started_at, callData.call_ended_at)}
//                 </p>
//               </div>
//             </div>

//             <div className="flex items-start gap-3">
//               {getCallTypeIcon(callData.call_type)}
//               <div>
//                 <p className="text-sm font-medium ">Call Type</p>
//                 <p className="text-sm text-gray-600">
//                   {getCallTypeLabel(callData.call_type)}
//                 </p>
//               </div>
//             </div>

//             {callData.customer_phone && (
//               <div className="flex items-start gap-3">
//                 <User className="h-5 w-5 shrink-0 mt-0.5" />
//                 <div>
//                   <p className="text-sm font-medium ">Customer Phone</p>
//                   <p className="text-sm text-gray-600">
//                     {callData.customer_phone}
//                   </p>
//                 </div>
//               </div>
//             )}

//             <div className="flex items-start gap-3">
//               <MessageSquare className="h-5 w-5 shrink-0 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium ">End Reason</p>
//                 <p className="text-sm text-gray-600">
//                   {callData.call_end_reason.replace(/-/g, ' ').replace(/\b\w/g, l => l.toUpperCase())}
//                 </p>
//               </div>
//             </div>
//           </CardContent>
//         </Card>

//         {/* Audio Player Card */}
//         <Card className="lg:col-span-2 border-indigo-100 shadow-sm">
//           <CardHeader className="border-b border-indigo-50 bg-indigo-50/30">
//             <CardTitle className="flex items-center gap-2 text-indigo-700">
//               <Volume2 className="h-5 w-5 text-indigo-500" />
//               Call Recording
//             </CardTitle>
//             <CardDescription>
//               Listen to the recorded conversation
//             </CardDescription>
//           </CardHeader>
//           <CardContent className="pt-6">
//             <audio
//               ref={audioRef}
//               src={callData.recording_url}
//               className="hidden"
//             />

//             <div className="space-y-4">
//               <div className="flex items-center justify-between">
//                 <span className="text-sm text-gray-600">
//                   {formatTime(currentTime)}
//                 </span>
//                 <span className="text-sm text-gray-600">
//                   {formatTime(duration)}
//                 </span>
//               </div>

//               <Slider
//                 value={[currentTime]}
//                 max={duration || 100}
//                 step={0.1}
//                 onValueChange={handleSeek}
//                 className="w-full"
//               />

//               <div className="flex justify-center items-center gap-4">
//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipBackward}
//                   title="Rewind 10 seconds"
//                   className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                 >
//                   <SkipBack className="h-5 w-5" />
//                 </Button>

//                 <Button
//                   size="icon"
//                   className="h-12 w-12 bg-indigo-600 hover:bg-indigo-700 text-white"
//                   onClick={togglePlayPause}
//                 >
//                   {isPlaying ? (
//                     <Pause className="h-6 w-6" />
//                   ) : (
//                     <Play className="h-6 w-6 ml-0.5" />
//                   )}
//                 </Button>

//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipForward}
//                   title="Forward 10 seconds"
//                   className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                 >
//                   <SkipForward className="h-5 w-5" />
//                 </Button>
//               </div>

//               <div className="flex items-center gap-2">
//                 <Volume2 className="h-4 w-4 text-indigo-400" />
//                 <Slider
//                   value={[volume]}
//                   max={1}
//                   step={0.01}
//                   onValueChange={handleVolumeChange}
//                   className="w-24"
//                 />
//               </div>
//             </div>
//           </CardContent>
//         </Card>
//       </div>

//       {/* Transcript Section */}
//       <Card className="mt-6 border-indigo-100 shadow-sm">
//         <CardHeader className="border-b border-indigo-50 bg-indigo-50/30">
//           <CardTitle className="flex items-center gap-2 text-indigo-700">
//             <MessageSquare className="h-5 w-5 text-indigo-500" />
//             Conversation Transcript
//           </CardTitle>
//           <CardDescription>
//             Complete transcript of the conversation between the bot and the user
//           </CardDescription>
//         </CardHeader>
//         <CardContent className="pt-6">
//           <div className="space-y-4">
//             {callData.messages.map((message, index) => (
//               <div
//                 key={index}
//                 className={`flex gap-4 ${message.role === 'bot' ? 'justify-start' : 'justify-end'}`}
//               >
//                 {message.role === 'bot' && (
//                   <Avatar>
//                     <AvatarFallback className="bg-indigo-100 text-indigo-700">
//                       B
//                     </AvatarFallback>
//                   </Avatar>
//                 )}

//                 <div className={`flex flex-col max-w-[80%] ${message.role === 'bot' ? 'items-start' : 'items-end'}`}>
//                   <div
//                     className={`px-4 py-3 rounded-lg ${
//                       message.role === 'bot'
//                         ? 'bg-indigo-50 text-gray-800 rounded-tl-none'
//                         : 'bg-indigo-600 text-white rounded-tr-none'
//                     }`}
//                   >
//                     {message.message}
//                   </div>
//                   <span className="text-xs text-gray-500 mt-1">
//                     {formatMessageTime(message.time)} • {(message.duration / 1000).toFixed(1)}s
//                   </span>
//                 </div>

//                 {message.role === 'user' && (
//                   <Avatar>
//                     <AvatarFallback className="bg-indigo-600 text-white">
//                       U
//                     </AvatarFallback>
//                   </Avatar>
//                 )}
//               </div>
//             ))}
//           </div>
//         </CardContent>
//       </Card>
//     </div>
//   );
// }

// import { useEffect, useState, useRef } from "react";
// import { useParams } from "react-router-dom";
// import { format } from "date-fns";
// import axios from "axios";
// import {
//   Card,
//   CardContent,
//   CardDescription,
//   CardHeader,
//   CardTitle,
//   CardFooter
// } from "@/components/ui/card";
// import { Avatar, AvatarFallback } from "@/components/ui/avatar";
// import { Badge } from "@/components/ui/badge";
// import { Separator } from "@/components/ui/separator";
// import { Tabs, TabsContent, TabsList, TabsTrigger } from "@/components/ui/tabs";
// import { Alert, AlertDescription, AlertTitle } from "@/components/ui/alert";
// import { ScrollArea } from "@/components/ui/scroll-area";
// import { Skeleton } from "@/components/ui/skeleton";
// import { Slider } from "@/components/ui/slider";
// import { Button } from "@/components/ui/button";
// import {
//   PhoneCall,
//   Clock,
//   Calendar,
//   User,
//   MessageSquare,
//   Play,
//   Pause,
//   SkipBack,
//   SkipForward,
//   Volume2,
//   Phone,
//   Globe,
//   FileText,
//   Info,
//   Headphones,
//   RefreshCw
// } from "lucide-react";

// // Types
// interface Message {
//   role: string;
//   time: number;
//   endTime: number;
//   message: string;
//   duration: number;
//   secondsFromStart: number;
//   source?: string;
// }

// interface CallData {
//   call_id: string;
//   call_started_at: string;
//   call_type: string;
//   call_ended_at: string;
//   recording_url: string;
//   customer_phone?: string;
//   call_status: string;
//   call_end_reason: string;
//   messages: Message[];
//   call_summary?: string;
// }

// export default function CallPage() {
//   const [isLoading, setIsLoading] = useState(true);
//   const [error, setError] = useState(false);
//   const [callData, setCallData] = useState<CallData | null>(null);
//   const { callId } = useParams();

//   // Audio player states
//   const audioRef = useRef<HTMLAudioElement | null>(null);
//   const [isPlaying, setIsPlaying] = useState(false);
//   const [currentTime, setCurrentTime] = useState(0);
//   const [duration, setDuration] = useState(0);
//   const [volume, setVolume] = useState(1);
//   const [activeTab, setActiveTab] = useState("transcript");

//   async function fetchCallData() {
//     try {
//       setIsLoading(true);
//       const response = await axios.get(`${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`, {
//         headers: {
//           Authorization: localStorage.getItem('token') as string
//         }
//       });
//       setError(false);
//       setCallData(response.data);
//     } catch (error) {
//       console.error(error);
//       setError(true);
//     } finally {
//       setIsLoading(false);
//     }
//   }

//   useEffect(() => {
//     fetchCallData();
//   }, [callId]);

//   // Audio player controls
//   useEffect(() => {
//     const audio = audioRef.current;
//     if (!audio) return;

//     const updateTime = () => setCurrentTime(audio.currentTime);
//     const updateDuration = () => {
//       if (audio.duration && !isNaN(audio.duration)) {
//         setDuration(audio.duration);
//       } else if (callData) {
//         setDuration(calculateCallDurationInSeconds(callData.call_started_at, callData.call_ended_at));
//       }
//     };
//     const handleEnded = () => setIsPlaying(false);

//     audio.addEventListener('timeupdate', updateTime);
//     audio.addEventListener('durationchange', updateDuration);
//     audio.addEventListener('ended', handleEnded);

//     // Set initial duration
//     if (callData) {
//       if (audio.duration && !isNaN(audio.duration)) {
//         setDuration(audio.duration);
//       } else {
//         setDuration(calculateCallDurationInSeconds(callData.call_started_at, callData.call_ended_at));
//       }
//     }

//     return () => {
//       audio.removeEventListener('timeupdate', updateTime);
//       audio.removeEventListener('durationchange', updateDuration);
//       audio.removeEventListener('ended', handleEnded);
//     };
//   }, [audioRef.current, callData]);

//   const togglePlayPause = () => {
//     if (!audioRef.current) return;
//     if (isPlaying) {
//       audioRef.current.pause();
//     } else {
//       audioRef.current.play();
//     }
//     setIsPlaying(!isPlaying);
//   };

//   const handleSeek = (value: number[]) => {
//     if (!audioRef.current) return;
//     const seekTime = value[0];
//     audioRef.current.currentTime = seekTime;
//     setCurrentTime(seekTime);
//   };

//   const handleVolumeChange = (value: number[]) => {
//     if (!audioRef.current) return;
//     const newVolume = value[0];
//     audioRef.current.volume = newVolume;
//     setVolume(newVolume);
//   };

//   const skipBackward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.max(0, audioRef.current.currentTime - 10);
//   };

//   const skipForward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.min(duration, audioRef.current.currentTime + 10);
//   };

//   // Utility functions
//   const formatTime = (time: number) => {
//     const minutes = Math.floor(time / 60);
//     const seconds = Math.floor(time % 60);
//     return `${minutes}:${seconds.toString().padStart(2, '0')}`;
//   };

//   const formatDate = (dateString: string) => {
//     return format(new Date(dateString), "MMM d, yyyy 'at' h:mm a");
//   };

//   const formatMessageTime = (timestamp: number) => {
//     return format(new Date(timestamp), "h:mm:ss a");
//   };

//   const getCallTypeLabel = (type: string) => {
//     switch (type) {
//       case "inboundPhoneCall":
//         return "Inbound Phone Call";
//       case "outboundPhoneCall":
//         return "Outbound Phone Call";
//       case "webCall":
//         return "Web Call";
//       default:
//         return type.replace(/([A-Z])/g, ' $1').trim();
//     }
//   };

//   const getCallTypeIcon = (type: string) => {
//     if (type.includes("PhoneCall")) {
//       return <Phone className="h-5 w-5 text-indigo-500" />;
//     } else if (type === "webCall") {
//       return <Globe className="h-5 w-5 text-indigo-500" />;
//     } else {
//       return <MessageSquare className="h-5 w-5 text-indigo-500" />;
//     }
//   };

//   const getStatusColor = (status: string) => {
//     switch (status) {
//       case "ended":
//         return "bg-emerald-100 text-emerald-800 border-emerald-200";
//       case "in-progress":
//         return "bg-blue-100 text-blue-800 border-blue-200";
//       case "missed":
//         return "bg-red-100 text-red-800 border-red-200";
//       default:
//         return "bg-gray-100 text-gray-800 border-gray-200";
//     }
//   };

//   const calculateCallDuration = (start: string, end: string) => {
//     const durationInSeconds = calculateCallDurationInSeconds(start, end);
//     const minutes = Math.floor(durationInSeconds / 60);
//     const seconds = Math.floor(durationInSeconds % 60);
//     return `${minutes}m ${seconds}s`;
//   };

//   const calculateCallDurationInSeconds = (start: string, end: string) => {
//     const startTime = new Date(start).getTime();
//     const endTime = new Date(end).getTime();
//     return (endTime - startTime) / 1000;
//   };

//   if (isLoading) {
//     return (
//       <div className="container mx-auto px-4 py-8 max-w-6xl">
//         <div className="space-y-6">
//           <div className="flex items-center space-x-4">
//             <Skeleton className="h-12 w-12 rounded-full" />
//             <div className="space-y-2">
//               <Skeleton className="h-4 w-[250px]" />
//               <Skeleton className="h-4 w-[200px]" />
//             </div>
//           </div>
//           <div className="grid gap-6 md:grid-cols-3">
//             <Skeleton className="h-64 rounded-lg" />
//             <Skeleton className="h-64 rounded-lg md:col-span-2" />
//           </div>
//           <Skeleton className="h-96 rounded-lg" />
//         </div>
//       </div>
//     );
//   }

//   if (error || !callData) {
//     return (
//       <div className="container mx-auto px-4 py-8 max-w-6xl">
//         <Alert variant="destructive">
//           <AlertTitle>Error</AlertTitle>
//           <AlertDescription>Failed to load call data. Please try again later.</AlertDescription>
//         </Alert>
//         <Button
//           className="mt-4"
//           onClick={fetchCallData}
//         >
//           <RefreshCw className="mr-2 h-4 w-4" />
//           Retry
//         </Button>
//       </div>
//     );
//   }

//   return (
//     <div className="container mx-auto px-4 py-8 max-w-6xl">
//       {/* Page Header */}
//       <div className="mb-6">
//         <div className="flex flex-col sm:flex-row justify-between items-start sm:items-center gap-4">
//           <div className="flex items-center gap-3">
//             <div className="h-12 w-12 rounded-full bg-indigo-100 flex items-center justify-center">
//               <PhoneCall className="h-6 w-6 text-indigo-600" />
//             </div>
//             <div>
//               <h1 className="text-2xl font-bold text-gray-800">Call Details</h1>
//               <p className="text-sm text-gray-500">
//                 ID: <span className="font-mono">{callData.call_id}</span>
//               </p>
//             </div>
//           </div>
//           <div className="flex flex-wrap gap-2 items-center">
//             <Badge
//               className={`text-sm px-3 py-1 rounded-full border ${getStatusColor(callData.call_status)}`}
//             >
//               {callData.call_status.charAt(0).toUpperCase() + callData.call_status.slice(1)}
//             </Badge>
//             <Badge
//               variant="outline"
//               className="bg-indigo-50 text-indigo-700 border-indigo-200 flex items-center gap-1"
//             >
//               {getCallTypeIcon(callData.call_type)}
//               {getCallTypeLabel(callData.call_type)}
//             </Badge>
//           </div>
//         </div>
//         <Separator className="my-4" />
//       </div>

//       {/* Main Content */}
//       <div className="grid gap-6 lg:grid-cols-3">
//         {/* Left Column - Call Info */}
//         <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center gap-2">
//               <Info className="h-5 w-5 text-indigo-500" />
//               <CardTitle className="text-lg font-semibold text-indigo-700">Call Information</CardTitle>
//             </div>
//           </CardHeader>
//           <CardContent className="space-y-4 pt-4">
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">Start Time</p>
//                 <p className="text-sm text-gray-600">{formatDate(callData.call_started_at)}</p>
//               </div>
//             </div>
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">End Time</p>
//                 <p className="text-sm text-gray-600">{formatDate(callData.call_ended_at)}</p>
//               </div>
//             </div>
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Clock className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">Duration</p>
//                 <p className="text-sm text-gray-600">{calculateCallDuration(callData.call_started_at, callData.call_ended_at)}</p>
//               </div>
//             </div>
//             {callData.customer_phone && (
//               <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//                 <User className="h-5 w-5 text-indigo-400 mt-0.5" />
//                 <div>
//                   <p className="text-sm font-medium text-gray-700">Customer Phone</p>
//                   <p className="text-sm text-gray-600">{callData.customer_phone}</p>
//                 </div>
//               </div>
//             )}
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <MessageSquare className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">End Reason</p>
//                 <p className="text-sm text-gray-600">
//                   {callData.call_end_reason.replace(/-/g, ' ').replace(/\b\w/g, l => l.toUpperCase())}
//                 </p>
//               </div>
//             </div>
//           </CardContent>
//         </Card>

//         {/* Right Column - Audio Player */}
//         <Card className="lg:col-span-2 border-indigo-100 shadow-sm overflow-hidden">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center justify-between">
//               <div className="flex items-center gap-2">
//                 <Headphones className="h-5 w-5 text-indigo-500" />
//                 <CardTitle className="text-lg font-semibold text-indigo-700">Call Recording</CardTitle>
//               </div>
//               <Badge variant="outline" className="bg-white border-indigo-200 text-indigo-600">
//                 {formatTime(currentTime)} / {formatTime(duration)}
//               </Badge>
//             </div>
//           </CardHeader>
//           <CardContent className="pt-6 pb-0">
//             <audio
//               ref={audioRef}
//               src={callData.recording_url}
//               className="hidden"
//             />
//             <div className="space-y-6">
//               <Slider
//                 value={[currentTime]}
//                 max={duration || 100}
//                 step={0.1}
//                 onValueChange={handleSeek}
//                 className="w-full"
//               />
//               <div className="flex justify-center items-center gap-4">
//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipBackward}
//                   title="Rewind 10 seconds"
//                   className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                 >
//                   <SkipBack className="h-5 w-5" />
//                 </Button>
//                 <Button
//                   size="icon"
//                   className="h-14 w-14 rounded-full bg-indigo-600 hover:bg-indigo-700 text-white shadow-md"
//                   onClick={togglePlayPause}
//                 >
//                   {isPlaying ? (
//                     <Pause className="h-6 w-6" />
//                   ) : (
//                     <Play className="h-6 w-6 ml-0.5" />
//                   )}
//                 </Button>
//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipForward}
//                   title="Forward 10 seconds"
//                   className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                 >
//                   <SkipForward className="h-5 w-5" />
//                 </Button>
//               </div>
//             </div>
//           </CardContent>
//           <CardFooter className="flex justify-end py-4">
//             <div className="flex items-center gap-2">
//               <Volume2 className="h-4 w-4 text-gray-500" />
//               <Slider
//                 value={[volume]}
//                 max={1}
//                 step={0.01}
//                 onValueChange={handleVolumeChange}
//                 className="w-24"
//               />
//             </div>
//           </CardFooter>
//         </Card>
//       </div>

//       {/* Content Tabs - Summary and Transcript */}
//       <Card className="mt-6 border-indigo-100 shadow-sm overflow-hidden">
//         <CardHeader className="p-0 border-b-0">
//           <Tabs value={activeTab} onValueChange={setActiveTab} className="w-full">
//             <TabsList className="grid grid-cols-2 w-full rounded-none bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100">
//               <TabsTrigger
//                 value="transcript"
//                 className="data-[state=active]:bg-white data-[state=active]:border-b-2 data-[state=active]:border-indigo-500 data-[state=active]:shadow-none rounded-none"
//               >
//                 <MessageSquare className="h-4 w-4 mr-2" />
//                 Transcript
//               </TabsTrigger>
//               <TabsTrigger
//                 value="summary"
//                 className="data-[state=active]:bg-white data-[state=active]:border-b-2 data-[state=active]:border-indigo-500 data-[state=active]:shadow-none rounded-none"
//               >
//                 <FileText className="h-4 w-4 mr-2" />
//                 Summary
//               </TabsTrigger>
//             </TabsList>
//           </Tabs>
//         </CardHeader>

//         <TabsContent value="transcript" className="m-0">
//           <ScrollArea className="h-[500px] p-6">
//             <div className="space-y-6">
//               {callData.messages.map((message, index) => (
//                 <div
//                   key={index}
//                   className={`flex gap-4 ${message.role === 'bot' ? 'justify-start' : 'justify-end'}`}
//                 >
//                   {message.role === 'bot' && (
//                     <Avatar>
//                       <AvatarFallback className="bg-indigo-100 text-indigo-700">
//                         B
//                       </AvatarFallback>
//                     </Avatar>
//                   )}
//                   <div className={`flex flex-col max-w-[75%] ${message.role === 'bot' ? 'items-start' : 'items-end'}`}>
//                     <div
//                       className={`px-4 py-3 rounded-lg ${
//                         message.role === 'bot'
//                           ? 'bg-indigo-50 text-gray-800 rounded-tl-none border border-indigo-100'
//                           : 'bg-indigo-600 text-white rounded-tr-none'
//                       }`}
//                     >
//                       {message.message}
//                     </div>
//                     <div className="flex items-center gap-2 mt-1">
//                       <span className="text-xs text-gray-500">
//                         {formatMessageTime(message.time)}
//                       </span>
//                       <Badge variant="outline" className="text-xs bg-gray-50 border-gray-200 px-1">
//                         {(message.duration / 1000).toFixed(1)}s
//                       </Badge>
//                     </div>
//                   </div>
//                   {message.role === 'user' && (
//                     <Avatar>
//                       <AvatarFallback className="bg-indigo-600 text-white">
//                         U
//                       </AvatarFallback>
//                     </Avatar>
//                   )}
//                 </div>
//               ))}
//             </div>
//           </ScrollArea>
//         </TabsContent>

//         <TabsContent value="summary" className="m-0">
//           <div className="p-6">
//             {callData.call_summary ? (
//               <div className="prose max-w-none">
//                 <h3 className="text-lg font-semibold text-indigo-700 mb-4">Call Summary</h3>
//                 <div className="bg-gray-50 border border-gray-200 rounded-lg p-4 text-gray-700">
//                   {callData.call_summary}
//                 </div>
//               </div>
//             ) : (
//               <div className="text-center py-12">
//                 <FileText className="h-12 w-12 text-gray-300 mx-auto mb-4" />
//                 <h3 className="text-lg font-medium text-gray-700">No Summary Available</h3>
//                 <p className="text-gray-500 mt-2">A summary for this call has not been generated yet.</p>
//               </div>
//             )}
//           </div>
//         </TabsContent>
//       </Card>
//     </div>
//   );
// }





// import { useEffect, useState, useRef } from "react";
// import { useParams } from "react-router-dom";
// import { format } from "date-fns";
// import axios from "axios";
// import {
//   Card,
//   CardContent,
//   CardDescription,
//   CardHeader,
//   CardTitle,
//   CardFooter,
// } from "@/components/ui/card";
// import { Avatar, AvatarFallback } from "@/components/ui/avatar";
// import { Badge } from "@/components/ui/badge";
// import { Separator } from "@/components/ui/separator";
// import { Tabs, TabsContent, TabsList, TabsTrigger } from "@/components/ui/tabs";
// import { Alert, AlertDescription, AlertTitle } from "@/components/ui/alert";
// import { ScrollArea } from "@/components/ui/scroll-area";
// import { Skeleton } from "@/components/ui/skeleton";
// import { Slider } from "@/components/ui/slider";
// import { Button } from "@/components/ui/button";
// import {
//   PhoneCall,
//   Clock,
//   Calendar,
//   User,
//   MessageSquare,
//   Play,
//   Pause,
//   SkipBack,
//   SkipForward,
//   Volume2,
//   Phone,
//   Globe,
//   FileText,
//   Info,
//   Headphones,
//   RefreshCw,
// } from "lucide-react";

// // Types
// interface Message {
//   role: string;
//   time: number;
//   endTime: number;
//   message: string;
//   duration: number;
//   secondsFromStart: number;
//   source?: string;
// }

// interface CallData {
//   call_id: string;
//   call_started_at: string;
//   call_type: string;
//   call_ended_at: string;
//   recording_url: string;
//   customer_phone?: string;
//   call_status: string;
//   call_end_reason: string;
//   messages: Message[];
//   call_summary?: string;
// }

// export default function CallPage() {
//   const [isLoading, setIsLoading] = useState(true);
//   const [error, setError] = useState(false);
//   const [callData, setCallData] = useState<CallData | null>(null);
//   const { callId } = useParams();

//   // Audio player states
//   const audioRef = useRef<HTMLAudioElement | null>(null);
//   const [isPlaying, setIsPlaying] = useState(false);
//   const [currentTime, setCurrentTime] = useState(0);
//   const [duration, setDuration] = useState(0);
//   const [volume, setVolume] = useState(1);
//   const [activeTab, setActiveTab] = useState("transcript");
//   const [waveformBars, setWaveformBars] = useState<number[]>([]);

//   async function fetchCallData() {
//     try {
//       setIsLoading(true);
//       const response = await axios.get(
//         `${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`,
//         {
//           headers: {
//             Authorization: localStorage.getItem("token") as string,
//           },
//         }
//       );
//       setError(false);
//       setCallData(response.data);
//     } catch (error) {
//       console.error(error);
//       setError(true);
//     } finally {
//       setIsLoading(false);
//     }
//   }

//   useEffect(() => {
//     fetchCallData();

//     // Generate random heights for waveform bars (between 10% and 100%)
//     const bars = Array.from(
//       { length: 40 },
//       () => Math.floor(Math.random() * 90) + 10
//     );
//     setWaveformBars(bars);
//   }, [callId]);

//   // Audio player controls
//   useEffect(() => {
//     const audio = audioRef.current;
//     if (!audio) return;

//     const updateTime = () => setCurrentTime(audio.currentTime);
//     const updateDuration = () => {
//       if (audio.duration && !isNaN(audio.duration)) {
//         setDuration(audio.duration);
//       } else if (callData) {
//         setDuration(
//           calculateCallDurationInSeconds(
//             callData.call_started_at,
//             callData.call_ended_at
//           )
//         );
//       }
//     };
//     const handleEnded = () => setIsPlaying(false);

//     audio.addEventListener("timeupdate", updateTime);
//     audio.addEventListener("durationchange", updateDuration);
//     audio.addEventListener("ended", handleEnded);

//     // Set initial duration
//     if (callData) {
//       if (audio.duration && !isNaN(audio.duration)) {
//         setDuration(audio.duration);
//       } else {
//         setDuration(
//           calculateCallDurationInSeconds(
//             callData.call_started_at,
//             callData.call_ended_at
//           )
//         );
//       }
//     }

//     return () => {
//       audio.removeEventListener("timeupdate", updateTime);
//       audio.removeEventListener("durationchange", updateDuration);
//       audio.removeEventListener("ended", handleEnded);
//     };
//   }, [audioRef.current, callData]);

//   useEffect(() => {
//     let intervalId: any;

//     if (isPlaying) {
//       intervalId = setInterval(() => {
//         setWaveformBars((prevBars) => {
//           return prevBars.map((height) => {
//             // Randomly adjust bar heights for animation effect
//             const newHeight = height + (Math.random() * 30 - 15);
//             return Math.min(100, Math.max(10, newHeight));
//           });
//         });
//       }, 200);
//     }

//     return () => {
//       if (intervalId) clearInterval(intervalId);
//     };
//   }, [isPlaying]);

//   const togglePlayPause = () => {
//     if (!audioRef.current) return;
//     if (isPlaying) {
//       audioRef.current.pause();
//     } else {
//       audioRef.current.play();
//     }
//     setIsPlaying(!isPlaying);
//   };

//   const handleSeek = (value: number[]) => {
//     if (!audioRef.current) return;
//     const seekTime = value[0];
//     audioRef.current.currentTime = seekTime;
//     setCurrentTime(seekTime);
//   };

//   const handleVolumeChange = (value: number[]) => {
//     if (!audioRef.current) return;
//     const newVolume = value[0];
//     audioRef.current.volume = newVolume;
//     setVolume(newVolume);
//   };

//   const skipBackward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.max(
//       0,
//       audioRef.current.currentTime - 10
//     );
//   };

//   const skipForward = () => {
//     if (!audioRef.current) return;
//     audioRef.current.currentTime = Math.min(
//       duration,
//       audioRef.current.currentTime + 10
//     );
//   };

//   // Utility functions
//   const formatTime = (time: number) => {
//     const minutes = Math.floor(time / 60);
//     const seconds = Math.floor(time % 60);
//     return `${minutes}:${seconds.toString().padStart(2, "0")}`;
//   };

//   const formatDate = (dateString: string) => {
//     return format(new Date(dateString), "MMM d, yyyy 'at' h:mm a");
//   };

//   const formatMessageTime = (timestamp: number) => {
//     return format(new Date(timestamp), "h:mm:ss a");
//   };

//   const getCallTypeLabel = (type: string) => {
//     switch (type) {
//       case "inboundPhoneCall":
//         return "Inbound Phone Call";
//       case "outboundPhoneCall":
//         return "Outbound Phone Call";
//       case "webCall":
//         return "Web Call";
//       default:
//         return type.replace(/([A-Z])/g, " $1").trim();
//     }
//   };

//   const getCallTypeIcon = (type: string) => {
//     if (type.includes("PhoneCall")) {
//       return <Phone className="h-5 w-5 text-indigo-500" />;
//     } else if (type === "webCall") {
//       return <Globe className="h-5 w-5 text-indigo-500" />;
//     } else {
//       return <MessageSquare className="h-5 w-5 text-indigo-500" />;
//     }
//   };

//   const getStatusColor = (status: string) => {
//     switch (status) {
//       case "ended":
//         return "bg-emerald-100 text-emerald-800 border-emerald-200";
//       case "in-progress":
//         return "bg-blue-100 text-blue-800 border-blue-200";
//       case "missed":
//         return "bg-red-100 text-red-800 border-red-200";
//       default:
//         return "bg-gray-100 text-gray-800 border-gray-200";
//     }
//   };

//   const calculateCallDuration = (start: string, end: string) => {
//     const durationInSeconds = calculateCallDurationInSeconds(start, end);
//     const minutes = Math.floor(durationInSeconds / 60);
//     const seconds = Math.floor(durationInSeconds % 60);
//     return `${minutes}m ${seconds}s`;
//   };

//   const calculateCallDurationInSeconds = (start: string, end: string) => {
//     const startTime = new Date(start).getTime();
//     const endTime = new Date(end).getTime();
//     return (endTime - startTime) / 1000;
//   };

//   if (isLoading) {
//     return (
//       <div className="container mx-auto px-4 py-8 max-w-6xl">
//         <div className="space-y-6">
//           <div className="flex items-center space-x-4">
//             <Skeleton className="h-12 w-12 rounded-full" />
//             <div className="space-y-2">
//               <Skeleton className="h-4 w-[250px]" />
//               <Skeleton className="h-4 w-[200px]" />
//             </div>
//           </div>
//           <div className="grid gap-6 md:grid-cols-3">
//             <Skeleton className="h-64 rounded-lg" />
//             <Skeleton className="h-64 rounded-lg md:col-span-2" />
//           </div>
//           <Skeleton className="h-96 rounded-lg" />
//         </div>
//       </div>
//     );
//   }

//   if (error || !callData) {
//     return (
//       <div className="container mx-auto px-4 py-8 max-w-6xl">
//         <Alert variant="destructive">
//           <AlertTitle>Error</AlertTitle>
//           <AlertDescription>
//             Failed to load call data. Please try again later.
//           </AlertDescription>
//         </Alert>
//         <Button className="mt-4" onClick={fetchCallData}>
//           <RefreshCw className="mr-2 h-4 w-4" />
//           Retry
//         </Button>
//       </div>
//     );
//   }

//   return (
//     <div className="container mx-auto px-4 py-8 max-w-6xl">
//       {/* Page Header */}
//       <div className="mb-6">
//         <div className="flex flex-col sm:flex-row justify-between items-start sm:items-center gap-4">
//           <div className="flex items-center gap-3">
//             <div className="h-12 w-12 rounded-full bg-indigo-100 flex items-center justify-center">
//               <PhoneCall className="h-6 w-6 text-indigo-600" />
//             </div>
//             <div>
//               <h1 className="text-2xl font-bold text-gray-800">Call Details</h1>
//               <p className="text-sm text-gray-500">
//                 ID: <span className="font-mono">{callData.call_id}</span>
//               </p>
//             </div>
//           </div>
//           <div className="flex flex-wrap gap-2 items-center">
//             <Badge
//               className={`text-sm px-3 py-1 rounded-full border ${getStatusColor(
//                 callData.call_status
//               )}`}
//             >
//               {callData.call_status.charAt(0).toUpperCase() +
//                 callData.call_status.slice(1)}
//             </Badge>
//             <Badge
//               variant="outline"
//               className="bg-indigo-50 text-indigo-700 border-indigo-200 flex items-center gap-1"
//             >
//               {getCallTypeIcon(callData.call_type)}
//               {getCallTypeLabel(callData.call_type)}
//             </Badge>
//           </div>
//         </div>
//         <Separator className="my-4" />
//       </div>

//       {/* Main Content */}
//       <div className="grid gap-6 lg:grid-cols-3">
//         {/* Left Column - Call Info */}
//         <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center gap-2">
//               <Info className="h-5 w-5 text-indigo-500" />
//               <CardTitle className="text-lg font-semibold text-indigo-700">
//                 Call Information
//               </CardTitle>
//             </div>
//           </CardHeader>
//           <CardContent className="space-y-4 pt-4">
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">Start Time</p>
//                 <p className="text-sm text-gray-600">
//                   {formatDate(callData.call_started_at)}
//                 </p>
//               </div>
//             </div>
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">End Time</p>
//                 <p className="text-sm text-gray-600">
//                   {formatDate(callData.call_ended_at)}
//                 </p>
//               </div>
//             </div>
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Clock className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">Duration</p>
//                 <p className="text-sm text-gray-600">
//                   {calculateCallDuration(
//                     callData.call_started_at,
//                     callData.call_ended_at
//                   )}
//                 </p>
//               </div>
//             </div>
//             {callData.customer_phone && (
//               <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//                 <User className="h-5 w-5 text-indigo-400 mt-0.5" />
//                 <div>
//                   <p className="text-sm font-medium text-gray-700">
//                     Customer Phone
//                   </p>
//                   <p className="text-sm text-gray-600">
//                     {callData.customer_phone}
//                   </p>
//                 </div>
//               </div>
//             )}
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <MessageSquare className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">End Reason</p>
//                 <p className="text-sm text-gray-600">
//                   {callData.call_end_reason
//                     .replace(/-/g, " ")
//                     .replace(/\b\w/g, (l) => l.toUpperCase())}
//                 </p>
//               </div>
//             </div>
//           </CardContent>
//         </Card>

//         {/* Right Column - Audio Player */}
//         {/* <Card className="lg:col-span-2 border-indigo-100 shadow-sm overflow-hidden">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center justify-between">
//               <div className="flex items-center gap-2">
//                 <Headphones className="h-5 w-5 text-indigo-500" />
//                 <CardTitle className="text-lg font-semibold text-indigo-700">
//                   Call Recording
//                 </CardTitle>
//               </div>
//               <Badge
//                 variant="outline"
//                 className="bg-white border-indigo-200 text-indigo-600"
//               >
//                 {formatTime(currentTime)} / {formatTime(duration)}
//               </Badge>
//             </div>
//           </CardHeader>
//           <CardContent className="pt-6 pb-0">
//             <audio
//               ref={audioRef}
//               src={callData.recording_url}
//               className="hidden"
//             />
//             <div className="space-y-6">
//               <Slider
//                 value={[currentTime]}
//                 max={duration || 100}
//                 step={0.1}
//                 onValueChange={handleSeek}
//                 className="w-full"
//               />
//               <div className="flex justify-center items-center gap-4">
//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipBackward}
//                   title="Rewind 10 seconds"
//                   className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                 >
//                   <SkipBack className="h-5 w-5" />
//                 </Button>
//                 <Button
//                   size="icon"
//                   className="h-14 w-14 rounded-full bg-indigo-600 hover:bg-indigo-700 text-white shadow-md"
//                   onClick={togglePlayPause}
//                 >
//                   {isPlaying ? (
//                     <Pause className="h-6 w-6" />
//                   ) : (
//                     <Play className="h-6 w-6 ml-0.5" />
//                   )}
//                 </Button>
//                 <Button
//                   variant="outline"
//                   size="icon"
//                   onClick={skipForward}
//                   title="Forward 10 seconds"
//                   className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                 >
//                   <SkipForward className="h-5 w-5" />
//                 </Button>
//               </div>
//             </div>
//           </CardContent>
//           <CardFooter className="flex justify-start py-4">
//             <div className="flex items-center gap-2">
//               <Volume2 className="h-4 w-4 text-gray-500" />
//               <Slider
//                 value={[volume]}
//                 max={1}
//                 step={0.01}
//                 onValueChange={handleVolumeChange}
//                 className="w-24"
//               />
//             </div>
//           </CardFooter>
//         </Card> */}

//         <Card className="lg:col-span-2 border-indigo-100 shadow-sm overflow-hidden">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center justify-between">
//               <div className="flex items-center gap-2">
//                 <Headphones className="h-5 w-5 text-indigo-500" />
//                 <CardTitle className="text-lg font-semibold text-indigo-700">
//                   Call Recording
//                 </CardTitle>
//               </div>
//               <Badge
//                 variant="outline"
//                 className="bg-white border-indigo-200 text-indigo-600"
//               >
//                 {formatTime(currentTime)} / {formatTime(duration)}
//               </Badge>
//             </div>
//           </CardHeader>
//           <CardContent className="pt-6 pb-0">
//             <div className="flex flex-col justify-center">
//               <audio
//                 ref={audioRef}
//                 src={callData.recording_url}
//                 className="hidden"
//               />
//               <div className="h-20 flex items-center justify-center">
//                 <div className="flex items-end h-16 gap-0.5 w-full justify-center">
//                   {waveformBars.map((height, index) => (
//                     <div
//                       key={index}
//                       className={`w-1.5 rounded-t-full transition-all duration-200 ${
//                         isPlaying ? "bg-indigo-500" : "bg-indigo-200"
//                       }`}
//                       style={{
//                         height: `${isPlaying ? height : height * 0.5}%`,
//                         opacity: isPlaying ? 1 : 0.7,
//                       }}
//                     />
//                   ))}
//                 </div>
//               </div>
//               <div className="space-y-4 mt-4">
//                 <Slider
//                   value={[currentTime]}
//                   max={duration || 100}
//                   step={0.1}
//                   onValueChange={handleSeek}
//                   className="w-full"
//                 />
//                 <div className="flex justify-between items-center">
//                   <div className="flex items-center gap-4">
//                     <Button
//                       variant="outline"
//                       size="icon"
//                       onClick={skipBackward}
//                       title="Rewind 10 seconds"
//                       className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                     >
//                       <SkipBack className="h-5 w-5" />
//                     </Button>
//                     <Button
//                       size="icon"
//                       className="h-14 w-14 rounded-full bg-indigo-600 hover:bg-indigo-700 text-white shadow-md"
//                       onClick={togglePlayPause}
//                     >
//                       {isPlaying ? (
//                         <Pause className="h-6 w-6" />
//                       ) : (
//                         <Play className="h-6 w-6 ml-0.5" />
//                       )}
//                     </Button>
//                     <Button
//                       variant="outline"
//                       size="icon"
//                       onClick={skipForward}
//                       title="Forward 10 seconds"
//                       className="text-indigo-600 border-indigo-200 hover:bg-indigo-50"
//                     >
//                       <SkipForward className="h-5 w-5" />
//                     </Button>
//                   </div>
//                   <div className="flex items-center gap-2">
//                     <Volume2 className="h-4 w-4 text-gray-500" />
//                     <Slider
//                       value={[volume]}
//                       max={1}
//                       step={0.01}
//                       onValueChange={handleVolumeChange}
//                       className="w-24"
//                     />
//                   </div>
//                 </div>
//               </div>
//             </div>
//           </CardContent>
//         </Card>
//       </div>

//       {/* Content Tabs - Summary and Transcript */}
//       <Card className="mt-6 border-indigo-100 shadow-sm overflow-hidden">
//         <Tabs value={activeTab} onValueChange={setActiveTab} className="w-full">
//           <CardHeader className="p-0 border-b-0">
//             <TabsList className="grid grid-cols-2 w-full rounded-none bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100">
//               <TabsTrigger
//                 value="transcript"
//                 className="data-[state=active]:bg-white data-[state=active]:border-b-2 data-[state=active]:border-indigo-500 data-[state=active]:shadow-none rounded-none"
//               >
//                 <MessageSquare className="h-4 w-4 mr-2" />
//                 Transcript
//               </TabsTrigger>
//               <TabsTrigger
//                 value="summary"
//                 className="data-[state=active]:bg-white data-[state=active]:border-b-2 data-[state=active]:border-indigo-500 data-[state=active]:shadow-none rounded-none"
//               >
//                 <FileText className="h-4 w-4 mr-2" />
//                 Summary
//               </TabsTrigger>
//             </TabsList>
//           </CardHeader>

//           <TabsContent value="transcript" className="m-0">
//             <ScrollArea className="h-[500px] p-6">
//               <div className="space-y-6">
//                 {callData.messages.map((message, index) => (
//                   <div
//                     key={index}
//                     className={`flex gap-4 ${
//                       message.role === "bot" ? "justify-start" : "justify-end"
//                     }`}
//                   >
//                     {message.role === "bot" && (
//                       <Avatar>
//                         <AvatarFallback className="bg-indigo-100 text-indigo-700">
//                           B
//                         </AvatarFallback>
//                       </Avatar>
//                     )}
//                     <div
//                       className={`flex flex-col max-w-[75%] ${
//                         message.role === "bot" ? "items-start" : "items-end"
//                       }`}
//                     >
//                       <div
//                         className={`px-4 py-3 rounded-lg ${
//                           message.role === "bot"
//                             ? "bg-indigo-50 text-gray-800 rounded-tl-none border border-indigo-100"
//                             : "bg-indigo-600 text-white rounded-tr-none"
//                         }`}
//                       >
//                         {message.message}
//                       </div>
//                       <div className="flex items-center gap-2 mt-1">
//                         <span className="text-xs text-gray-500">
//                           {formatMessageTime(message.time)}
//                         </span>
//                         <Badge
//                           variant="outline"
//                           className="text-xs bg-gray-50 border-gray-200 px-1"
//                         >
//                           {(message.duration / 1000).toFixed(1)}s
//                         </Badge>
//                       </div>
//                     </div>
//                     {message.role === "user" && (
//                       <Avatar>
//                         <AvatarFallback className="bg-indigo-600 text-white">
//                           U
//                         </AvatarFallback>
//                       </Avatar>
//                     )}
//                   </div>
//                 ))}
//               </div>
//             </ScrollArea>
//           </TabsContent>

//           <TabsContent value="summary" className="m-0">
//             <div className="p-6">
//               {callData.call_summary ? (
//                 <div className="prose max-w-none">
//                   <h3 className="text-lg font-semibold text-indigo-700 mb-4">
//                     Call Summary
//                   </h3>
//                   <div className="bg-gray-50 border border-gray-200 rounded-lg p-4 text-gray-700">
//                     {callData.call_summary}
//                   </div>
//                 </div>
//               ) : (
//                 <div className="text-center py-12">
//                   <FileText className="h-12 w-12 text-gray-300 mx-auto mb-4" />
//                   <h3 className="text-lg font-medium text-gray-700">
//                     No Summary Available
//                   </h3>
//                   <p className="text-gray-500 mt-2">
//                     A summary for this call has not been generated yet.
//                   </p>
//                 </div>
//               )}
//             </div>
//           </TabsContent>
//         </Tabs>
//       </Card>
//     </div>
//   );
// }



// import { useEffect, useState } from "react";
// import { useParams } from "react-router-dom";
// import { format } from "date-fns";
// import axios from "axios";
// import {
//   Card,
//   CardContent,
//   CardDescription,
//   CardHeader,
//   CardTitle,
//   CardFooter,
// } from "@/components/ui/card";
// import { Avatar, AvatarFallback } from "@/components/ui/avatar";
// import { Badge } from "@/components/ui/badge";
// import { Separator } from "@/components/ui/separator";
// import { Tabs, TabsContent, TabsList, TabsTrigger } from "@/components/ui/tabs";
// import { Alert, AlertDescription, AlertTitle } from "@/components/ui/alert";
// import { ScrollArea } from "@/components/ui/scroll-area";
// import { Skeleton } from "@/components/ui/skeleton";
// import { Button } from "@/components/ui/button";
// import {
//   PhoneCall,
//   Clock,
//   Calendar,
//   User,
//   MessageSquare,
//   Phone,
//   Globe,
//   FileText,
//   Info,
//   RefreshCw,
// } from "lucide-react";

// // Types
// interface Message {
//   role: string;
//   time: number;
//   endTime: number;
//   message: string;
//   duration: number;
//   secondsFromStart: number;
//   source?: string;
// }

// interface CallData {
//   call_id: string;
//   call_started_at: string;
//   call_type: string;
//   call_ended_at: string;
//   recording_url: string;
//   customer_phone?: string;
//   call_status: string;
//   call_end_reason: string;
//   messages: Message[];
//   call_summary?: string;
// }

// export default function CallPage() {
//   const [isLoading, setIsLoading] = useState(true);
//   const [error, setError] = useState(false);
//   const [callData, setCallData] = useState<CallData | null>(null);
//   const { callId } = useParams();
//   const [activeTab, setActiveTab] = useState("transcript");

//   async function fetchCallData() {
//     try {
//       setIsLoading(true);
//       const response = await axios.get(
//         `${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`,
//         {
//           headers: {
//             Authorization: localStorage.getItem("token") as string,
//           },
//         }
//       );
//       setError(false);
//       setCallData(response.data);
//     } catch (error) {
//       console.error(error);
//       setError(true);
//     } finally {
//       setIsLoading(false);
//     }
//   }

//   useEffect(() => {
//     fetchCallData();
//   }, [callId]);

//   // Utility functions
//   const formatDate = (dateString: string) => {
//     return format(new Date(dateString), "MMM d, yyyy 'at' h:mm a");
//   };

//   const formatMessageTime = (timestamp: number) => {
//     return format(new Date(timestamp), "h:mm:ss a");
//   };

//   const getCallTypeLabel = (type: string) => {
//     switch (type) {
//       case "inboundPhoneCall":
//         return "Inbound Phone Call";
//       case "outboundPhoneCall":
//         return "Outbound Phone Call";
//       case "webCall":
//         return "Web Call";
//       default:
//         return type.replace(/([A-Z])/g, " $1").trim();
//     }
//   };

//   const getCallTypeIcon = (type: string) => {
//     if (type.includes("PhoneCall")) {
//       return <Phone className="h-5 w-5 text-indigo-500" />;
//     } else if (type === "webCall") {
//       return <Globe className="h-5 w-5 text-indigo-500" />;
//     } else {
//       return <MessageSquare className="h-5 w-5 text-indigo-500" />;
//     }
//   };

//   const getStatusColor = (status: string) => {
//     switch (status) {
//       case "ended":
//         return "bg-emerald-100 text-emerald-800 border-emerald-200";
//       case "in-progress":
//         return "bg-blue-100 text-blue-800 border-blue-200";
//       case "missed":
//         return "bg-red-100 text-red-800 border-red-200";
//       default:
//         return "bg-gray-100 text-gray-800 border-gray-200";
//     }
//   };

//   const calculateCallDuration = (start: string, end: string) => {
//     const durationInSeconds = calculateCallDurationInSeconds(start, end);
//     const minutes = Math.floor(durationInSeconds / 60);
//     const seconds = Math.floor(durationInSeconds % 60);
//     return `${minutes}m ${seconds}s`;
//   };

//   const calculateCallDurationInSeconds = (start: string, end: string) => {
//     const startTime = new Date(start).getTime();
//     const endTime = new Date(end).getTime();
//     return (endTime - startTime) / 1000;
//   };

//   if (isLoading) {
//     return (
//       <div className="container mx-auto px-4 py-8 max-w-6xl">
//         <div className="space-y-6">
//           <div className="flex items-center space-x-4">
//             <Skeleton className="h-12 w-12 rounded-full" />
//             <div className="space-y-2">
//               <Skeleton className="h-4 w-[250px]" />
//               <Skeleton className="h-4 w-[200px]" />
//             </div>
//           </div>
//           <div className="grid gap-6 md:grid-cols-2">
//             <Skeleton className="h-64 rounded-lg" />
//             <Skeleton className="h-64 rounded-lg" />
//           </div>
//           <Skeleton className="h-96 rounded-lg" />
//         </div>
//       </div>
//     );
//   }

//   if (error || !callData) {
//     return (
//       <div className="container mx-auto px-4 py-8 max-w-6xl">
//         <Alert variant="destructive">
//           <AlertTitle>Error</AlertTitle>
//           <AlertDescription>
//             Failed to load call data. Please try again later.
//           </AlertDescription>
//         </Alert>
//         <Button className="mt-4" onClick={fetchCallData}>
//           <RefreshCw className="mr-2 h-4 w-4" />
//           Retry
//         </Button>
//       </div>
//     );
//   }

//   return (
//     <div className="container mx-auto px-4 py-8 max-w-6xl">
//       {/* Page Header */}
//       <div className="mb-6">
//         <div className="flex flex-col sm:flex-row justify-between items-start sm:items-center gap-4">
//           <div className="flex items-center gap-3">
//             <div className="h-12 w-12 rounded-full bg-indigo-100 flex items-center justify-center">
//               <PhoneCall className="h-6 w-6 text-indigo-600" />
//             </div>
//             <div>
//               <h1 className="text-2xl font-bold text-gray-800">Call Details</h1>
//               <p className="text-sm text-gray-500">
//                 ID: <span className="font-mono">{callData.call_id}</span>
//               </p>
//             </div>
//           </div>
//           <div className="flex flex-wrap gap-2 items-center">
//             <Badge
//               className={`text-sm px-3 py-1 rounded-full border ${getStatusColor(
//                 callData.call_status
//               )}`}
//             >
//               {callData.call_status.charAt(0).toUpperCase() +
//                 callData.call_status.slice(1)}
//             </Badge>
//             <Badge
//               variant="outline"
//               className="bg-indigo-50 text-indigo-700 border-indigo-200 flex items-center gap-1"
//             >
//               {getCallTypeIcon(callData.call_type)}
//               {getCallTypeLabel(callData.call_type)}
//             </Badge>
//           </div>
//         </div>
//         <Separator className="my-4" />
//       </div>

//       {/* Main Content */}
//       <div className="grid gap-6 lg:grid-cols-2">
//         {/* Call Info Card */}
//         <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center gap-2">
//               <Info className="h-5 w-5 text-indigo-500" />
//               <CardTitle className="text-lg font-semibold text-indigo-700">
//                 Call Information
//               </CardTitle>
//             </div>
//           </CardHeader>
//           <CardContent className="space-y-4 pt-4">
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">Start Time</p>
//                 <p className="text-sm text-gray-600">
//                   {formatDate(callData.call_started_at)}
//                 </p>
//               </div>
//             </div>
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">End Time</p>
//                 <p className="text-sm text-gray-600">
//                   {formatDate(callData.call_ended_at)}
//                 </p>
//               </div>
//             </div>
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <Clock className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">Duration</p>
//                 <p className="text-sm text-gray-600">
//                   {calculateCallDuration(
//                     callData.call_started_at,
//                     callData.call_ended_at
//                   )}
//                 </p>
//               </div>
//             </div>
//             {callData.customer_phone && (
//               <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//                 <User className="h-5 w-5 text-indigo-400 mt-0.5" />
//                 <div>
//                   <p className="text-sm font-medium text-gray-700">
//                     Customer Phone
//                   </p>
//                   <p className="text-sm text-gray-600">
//                     {callData.customer_phone}
//                   </p>
//                 </div>
//               </div>
//             )}
//             <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
//               <MessageSquare className="h-5 w-5 text-indigo-400 mt-0.5" />
//               <div>
//                 <p className="text-sm font-medium text-gray-700">End Reason</p>
//                 <p className="text-sm text-gray-600">
//                   {callData.call_end_reason
//                     .replace(/-/g, " ")
//                     .replace(/\b\w/g, (l) => l.toUpperCase())}
//                 </p>
//               </div>
//             </div>
//           </CardContent>
//         </Card>

//         {/* Summary Card */}
//         <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
//           <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//             <div className="flex items-center gap-2">
//               <FileText className="h-5 w-5 text-indigo-500" />
//               <CardTitle className="text-lg font-semibold text-indigo-700">
//                 Call Summary
//               </CardTitle>
//             </div>
//           </CardHeader>
//           <CardContent className="pt-4">
//             {callData.call_summary ? (
//               <div className="prose max-w-none">
//                 <div className="bg-gray-50 border border-gray-200 rounded-lg p-4 text-gray-700">
//                   {callData.call_summary}
//                 </div>
//               </div>
//             ) : (
//               <div className="text-center py-8">
//                 <FileText className="h-12 w-12 text-gray-300 mx-auto mb-4" />
//                 <h3 className="text-lg font-medium text-gray-700">
//                   No Summary Available
//                 </h3>
//                 <p className="text-gray-500 mt-2">
//                   A summary for this call has not been generated yet.
//                 </p>
//               </div>
//             )}
//           </CardContent>
//         </Card>
//       </div>

//       {/* Transcript Section */}
//       <Card className="mt-6 border-indigo-100 shadow-sm overflow-hidden">
//         <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
//           <div className="flex items-center gap-2">
//             <MessageSquare className="h-5 w-5 text-indigo-500" />
//             <CardTitle className="text-lg font-semibold text-indigo-700">
//               Call Transcript
//             </CardTitle>
//           </div>
//         </CardHeader>
//         <CardContent className="p-0">
//           <ScrollArea className="h-[500px] p-6">
//             <div className="space-y-6">
//               {callData.messages.map((message, index) => (
//                 <div
//                   key={index}
//                   className={`flex gap-4 ${
//                     message.role === "bot" ? "justify-start" : "justify-end"
//                   }`}
//                 >
//                   {message.role === "bot" && (
//                     <Avatar>
//                       <AvatarFallback className="bg-indigo-100 text-indigo-700">
//                         B
//                       </AvatarFallback>
//                     </Avatar>
//                   )}
//                   <div
//                     className={`flex flex-col max-w-[75%] ${
//                       message.role === "bot" ? "items-start" : "items-end"
//                     }`}
//                   >
//                     <div
//                       className={`px-4 py-3 rounded-lg ${
//                         message.role === "bot"
//                           ? "bg-indigo-50 text-gray-800 rounded-tl-none border border-indigo-100"
//                           : "bg-indigo-600 text-white rounded-tr-none"
//                       }`}
//                     >
//                       {message.message}
//                     </div>
//                     <div className="flex items-center gap-2 mt-1">
//                       <span className="text-xs text-gray-500">
//                         {formatMessageTime(message.time)}
//                       </span>
//                       <Badge
//                         variant="outline"
//                         className="text-xs bg-gray-50 border-gray-200 px-1"
//                       >
//                         {(message.duration / 1000).toFixed(1)}s
//                       </Badge>
//                     </div>
//                   </div>
//                   {message.role === "user" && (
//                     <Avatar>
//                       <AvatarFallback className="bg-indigo-600 text-white">
//                         U
//                       </AvatarFallback>
//                     </Avatar>
//                   )}
//                 </div>
//               ))}
//             </div>
//           </ScrollArea>
//         </CardContent>
//       </Card>
//     </div>
//   );
// }


import { useEffect, useState } from "react";
import { useParams } from "react-router-dom";
import { format } from "date-fns";
import axios from "axios";
import {
  Card,
  CardContent,
  CardDescription,
  CardHeader,
  CardTitle,
  CardFooter,
} from "@/components/ui/card";
import { Avatar, AvatarFallback } from "@/components/ui/avatar";
import { Badge } from "@/components/ui/badge";
import { Separator } from "@/components/ui/separator";
import { Tabs, TabsContent, TabsList, TabsTrigger } from "@/components/ui/tabs";
import { Alert, AlertDescription, AlertTitle } from "@/components/ui/alert";
import { ScrollArea } from "@/components/ui/scroll-area";
import { Skeleton } from "@/components/ui/skeleton";
import { Button } from "@/components/ui/button";
import {
  PhoneCall,
  Clock,
  Calendar,
  User,
  MessageSquare,
  Phone,
  Globe,
  FileText,
  Info,
  RefreshCw,
  Loader2,
} from "lucide-react";

// Types
interface Message {
  role: string;
  time: number;
  endTime: number;
  message: string;
  duration: number;
  secondsFromStart: number;
  source?: string;
}

interface CallData {
  call_id: string;
  call_started_at: string;
  call_type: string;
  call_ended_at?: string;
  recording_url?: string;
  customer_phone?: string;
  call_status: string;
  call_end_reason?: string;
  messages: Message[];
  call_summary?: string;
}

export default function CallPage() {
  const [isLoading, setIsLoading] = useState(true);
  const [error, setError] = useState(false);
  const [callData, setCallData] = useState<CallData | null>(null);
  const { callId } = useParams();
  const [activeTab, setActiveTab] = useState("transcript");
  const [refreshInterval, setRefreshInterval] = useState<number | null>(null);

  async function fetchCallData() {
    try {
      setIsLoading(true);
      const response = await axios.get(
        `${import.meta.env.VITE_BASE_API_URL}/user/call/${callId}`,
        {
          headers: {
            Authorization: localStorage.getItem("token") as string,
          },
        }
      );
      setError(false);
      setCallData(response.data);
      
      // Set up auto-refresh if call is in progress
      if (response.data.call_status === "in-progress") {
        if (!refreshInterval) {
          const interval = window.setInterval(() => {
            fetchCallData();
          }, 10000); // Refresh every 10 seconds
          setRefreshInterval(interval);
        }
      } else {
        // Clear interval if call is no longer in progress
        if (refreshInterval) {
          clearInterval(refreshInterval);
          setRefreshInterval(null);
        }
      }
    } catch (error) {
      console.error(error);
      setError(true);
    } finally {
      setIsLoading(false);
    }
  }

  useEffect(() => {
    fetchCallData();
    
    // Clean up interval on component unmount
    return () => {
      if (refreshInterval) {
        clearInterval(refreshInterval);
      }
    };
  }, [callId]);

  // Utility functions
  const formatDate = (dateString: string) => {
    return format(new Date(dateString), "MMM d, yyyy 'at' h:mm a");
  };

  const formatMessageTime = (timestamp: number) => {
    return format(new Date(timestamp), "h:mm:ss a");
  };

  const getCallTypeLabel = (type: string) => {
    switch (type) {
      case "inboundPhoneCall":
        return "Inbound Phone Call";
      case "outboundPhoneCall":
        return "Outbound Phone Call";
      case "webCall":
        return "Web Call";
      default:
        return type.replace(/([A-Z])/g, " $1").trim();
    }
  };

  const getCallTypeIcon = (type: string) => {
    if (type.includes("PhoneCall")) {
      return <Phone className="h-5 w-5 text-indigo-500" />;
    } else if (type === "webCall") {
      return <Globe className="h-5 w-5 text-indigo-500" />;
    } else {
      return <MessageSquare className="h-5 w-5 text-indigo-500" />;
    }
  };

  const getStatusColor = (status: string) => {
    switch (status) {
      case "ended":
        return "bg-emerald-100 text-emerald-800 border-emerald-200";
      case "in-progress":
        return "bg-blue-100 text-blue-800 border-blue-200";
      case "missed":
        return "bg-red-100 text-red-800 border-red-200";
      default:
        return "bg-gray-100 text-gray-800 border-gray-200";
    }
  };

  const calculateCallDuration = (start: string, end: string) => {
    const durationInSeconds = calculateCallDurationInSeconds(start, end);
    const minutes = Math.floor(durationInSeconds / 60);
    const seconds = Math.floor(durationInSeconds % 60);
    return `${minutes}m ${seconds}s`;
  };

  const calculateCallDurationInSeconds = (start: string, end: string) => {
    const startTime = new Date(start).getTime();
    const endTime = new Date(end).getTime();
    return (endTime - startTime) / 1000;
  };

  // Calculate elapsed time for in-progress calls
  const calculateElapsedTime = (startTime: string) => {
    const start = new Date(startTime).getTime();
    const now = new Date().getTime();
    const elapsedSeconds = Math.floor((now - start) / 1000);
    const minutes = Math.floor(elapsedSeconds / 60);
    const seconds = elapsedSeconds % 60;
    return `${minutes}m ${seconds}s`;
  };

  if (isLoading) {
    return (
      <div className="container mx-auto px-4 py-8 max-w-6xl">
        <div className="space-y-6">
          <div className="flex items-center space-x-4">
            <Skeleton className="h-12 w-12 rounded-full" />
            <div className="space-y-2">
              <Skeleton className="h-4 w-[250px]" />
              <Skeleton className="h-4 w-[200px]" />
            </div>
          </div>
          <div className="grid gap-6 md:grid-cols-2">
            <Skeleton className="h-64 rounded-lg" />
            <Skeleton className="h-64 rounded-lg" />
          </div>
          <Skeleton className="h-96 rounded-lg" />
        </div>
      </div>
    );
  }

  if (error || !callData) {
    return (
      <div className="container mx-auto px-4 py-8 max-w-6xl">
        <Alert variant="destructive">
          <AlertTitle>Error</AlertTitle>
          <AlertDescription>
            Failed to load call data. Please try again later.
          </AlertDescription>
        </Alert>
        <Button className="mt-4" onClick={fetchCallData}>
          <RefreshCw className="mr-2 h-4 w-4" />
          Retry
        </Button>
      </div>
    );
  }

  // In-progress call view
  if (callData.call_status === "in-progress") {
    return (
      <div className="container mx-auto px-4 py-8 max-w-6xl">
        {/* Page Header */}
        <div className="mb-6">
          <div className="flex flex-col sm:flex-row justify-between items-start sm:items-center gap-4">
            <div className="flex items-center gap-3">
              <div className="h-12 w-12 rounded-full bg-indigo-100 flex items-center justify-center">
                <PhoneCall className="h-6 w-6 text-indigo-600" />
              </div>
              <div>
                <h1 className="text-2xl font-bold text-gray-800">Call Details</h1>
                <p className="text-sm text-gray-500">
                  ID: <span className="font-mono">{callData.call_id}</span>
                </p>
              </div>
            </div>
            <div className="flex flex-wrap gap-2 items-center">
              <Badge
                className="text-sm px-3 py-1 rounded-full border bg-blue-100 text-blue-800 border-blue-200 animate-pulse"
              >
                In Progress
              </Badge>
              <Badge
                variant="outline"
                className="bg-indigo-50 text-indigo-700 border-indigo-200 flex items-center gap-1"
              >
                {getCallTypeIcon(callData.call_type)}
                {getCallTypeLabel(callData.call_type)}
              </Badge>
            </div>
          </div>
          <Separator className="my-4" />
        </div>

        {/* Active Call Notification */}
        <Alert className="mb-6 bg-blue-50 border-blue-200">
          <Loader2 className="h-5 w-5 text-blue-500 animate-spin" />
          <AlertTitle className="text-blue-700">Active Call in Progress</AlertTitle>
          <AlertDescription className="text-blue-600">
            This call is currently in progress. Transcript and summary will be available once the call ends. This page will automatically refresh.
          </AlertDescription>
        </Alert>

        {/* Main Content */}
        <div className="grid gap-6 lg:grid-cols-2">
          {/* Call Info Card */}
          <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
            <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
              <div className="flex items-center gap-2">
                <Info className="h-5 w-5 text-indigo-500" />
                <CardTitle className="text-lg font-semibold text-indigo-700">
                  Call Information
                </CardTitle>
              </div>
            </CardHeader>
            <CardContent className="space-y-4 pt-4">
              <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
                <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
                <div>
                  <p className="text-sm font-medium text-gray-700">Start Time</p>
                  <p className="text-sm text-gray-600">
                    {formatDate(callData.call_started_at)}
                  </p>
                </div>
              </div>
              <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
                <Clock className="h-5 w-5 text-indigo-400 mt-0.5" />
                <div>
                  <p className="text-sm font-medium text-gray-700">Duration</p>
                  <p className="text-sm text-gray-600 flex items-center">
                    {calculateElapsedTime(callData.call_started_at)}
                    <span className="ml-2 h-2 w-2 bg-blue-500 rounded-full animate-pulse"></span>
                  </p>
                </div>
              </div>
              {callData.customer_phone && (
                <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
                  <User className="h-5 w-5 text-indigo-400 mt-0.5" />
                  <div>
                    <p className="text-sm font-medium text-gray-700">
                      Customer Phone
                    </p>
                    <p className="text-sm text-gray-600">
                      {callData.customer_phone}
                    </p>
                  </div>
                </div>
              )}
            </CardContent>
          </Card>

          {/* Placeholder for Summary */}
          <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
            <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
              <div className="flex items-center gap-2">
                <FileText className="h-5 w-5 text-indigo-500" />
                <CardTitle className="text-lg font-semibold text-indigo-700">
                  Call Summary
                </CardTitle>
              </div>
            </CardHeader>
            <CardContent className="pt-4">
              <div className="text-center py-8">
                <div className="rounded-full bg-blue-100 h-16 w-16 flex items-center justify-center mx-auto mb-4">
                  <Loader2 className="h-8 w-8 text-blue-500 animate-spin" />
                </div>
                <h3 className="text-lg font-medium text-gray-700">
                  Call in Progress
                </h3>
                <p className="text-gray-500 mt-2">
                  The summary will be available once the call ends.
                </p>
              </div>
            </CardContent>
          </Card>
        </div>

        {/* Placeholder for Transcript */}
        <Card className="mt-6 border-indigo-100 shadow-sm overflow-hidden">
          <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
            <div className="flex items-center gap-2">
              <MessageSquare className="h-5 w-5 text-indigo-500" />
              <CardTitle className="text-lg font-semibold text-indigo-700">
                Call Transcript
              </CardTitle>
            </div>
          </CardHeader>
          <CardContent className="p-0">
            <div className="flex flex-col items-center justify-center py-16">
              <div className="rounded-full bg-blue-100 h-16 w-16 flex items-center justify-center mb-4">
                <PhoneCall className="h-8 w-8 text-blue-500" />
              </div>
              <h3 className="text-lg font-medium text-gray-700">
                Active Call in Progress
              </h3>
              <p className="text-gray-500 mt-2 text-center max-w-md">
                The transcript will be available once the call ends. This page will automatically refresh.
              </p>
              <Button variant="outline" className="mt-4" onClick={fetchCallData}>
                <RefreshCw className="mr-2 h-4 w-4" />
                Refresh Now
              </Button>
            </div>
          </CardContent>
        </Card>
      </div>
    );
  }

  // Regular call view (ended calls)
  return (
    <div className="container mx-auto px-4 py-8 max-w-6xl">
      {/* Page Header */}
      <div className="mb-6">
        <div className="flex flex-col sm:flex-row justify-between items-start sm:items-center gap-4">
          <div className="flex items-center gap-3">
            <div className="h-12 w-12 rounded-full bg-indigo-100 flex items-center justify-center">
              <PhoneCall className="h-6 w-6 text-indigo-600" />
            </div>
            <div>
              <h1 className="text-2xl font-bold text-gray-800">Call Details</h1>
              <p className="text-sm text-gray-500">
                ID: <span className="font-mono">{callData.call_id}</span>
              </p>
            </div>
          </div>
          <div className="flex flex-wrap gap-2 items-center">
            <Badge
              className={`text-sm px-3 py-1 rounded-full border ${getStatusColor(
                callData.call_status
              )}`}
            >
              {callData.call_status.charAt(0).toUpperCase() +
                callData.call_status.slice(1)}
            </Badge>
            <Badge
              variant="outline"
              className="bg-indigo-50 text-indigo-700 border-indigo-200 flex items-center gap-1"
            >
              {getCallTypeIcon(callData.call_type)}
              {getCallTypeLabel(callData.call_type)}
            </Badge>
          </div>
        </div>
        <Separator className="my-4" />
      </div>
      {/* Main Content */}
      <div className="grid gap-6 lg:grid-cols-2">
        {/* Call Info Card */}
        <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
          <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
            <div className="flex items-center gap-2">
              <Info className="h-5 w-5 text-indigo-500" />
              <CardTitle className="text-lg font-semibold text-indigo-700">
                Call Information
              </CardTitle>
            </div>
          </CardHeader>
          <CardContent className="space-y-4 pt-4">
            <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
              <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
              <div>
                <p className="text-sm font-medium text-gray-700">Start Time</p>
                <p className="text-sm text-gray-600">
                  {formatDate(callData.call_started_at)}
                </p>
              </div>
            </div>
            <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
              <Calendar className="h-5 w-5 text-indigo-400 mt-0.5" />
              <div>
                <p className="text-sm font-medium text-gray-700">End Time</p>
                <p className="text-sm text-gray-600">
                  {callData.call_ended_at ? formatDate(callData.call_ended_at) : "Not ended yet"}
                </p>
              </div>
            </div>
            <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
              <Clock className="h-5 w-5 text-indigo-400 mt-0.5" />
              <div>
                <p className="text-sm font-medium text-gray-700">Duration</p>
                <p className="text-sm text-gray-600">
                  {callData.call_ended_at
                    ? calculateCallDuration(
                        callData.call_started_at,
                        callData.call_ended_at
                      )
                    : "In progress"}
                </p>
              </div>
            </div>
            {callData.customer_phone && (
              <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
                <User className="h-5 w-5 text-indigo-400 mt-0.5" />
                <div>
                  <p className="text-sm font-medium text-gray-700">
                    Customer Phone
                  </p>
                  <p className="text-sm text-gray-600">
                    {callData.customer_phone}
                  </p>
                </div>
              </div>
            )}
            {callData.call_end_reason && (
              <div className="grid grid-cols-[24px_1fr] gap-3 items-start">
                <MessageSquare className="h-5 w-5 text-indigo-400 mt-0.5" />
                <div>
                  <p className="text-sm font-medium text-gray-700">End Reason</p>
                  <p className="text-sm text-gray-600">
                    {callData.call_end_reason
                      .replace(/-/g, " ")
                      .replace(/\b\w/g, (l) => l.toUpperCase())}
                  </p>
                </div>
              </div>
            )}
          </CardContent>
        </Card>
        {/* Summary Card */}
        <Card className="border-indigo-100 shadow-sm overflow-hidden h-fit">
          <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
            <div className="flex items-center gap-2">
              <FileText className="h-5 w-5 text-indigo-500" />
              <CardTitle className="text-lg font-semibold text-indigo-700">
                Call Summary
              </CardTitle>
            </div>
          </CardHeader>
          <CardContent className="pt-4">
            {callData.call_summary ? (
              <div className="prose max-w-none">
                <div className="bg-gray-50 border border-gray-200 rounded-lg p-4 text-gray-700">
                  {callData.call_summary}
                </div>
              </div>
            ) : (
              <div className="text-center py-8">
                <FileText className="h-12 w-12 text-gray-300 mx-auto mb-4" />
                <h3 className="text-lg font-medium text-gray-700">
                  No Summary Available
                </h3>
                <p className="text-gray-500 mt-2">
                  A summary for this call has not been generated yet.
                </p>
              </div>
            )}
          </CardContent>
        </Card>
      </div>
      {/* Transcript Section */}
      <Card className="mt-6 border-indigo-100 shadow-sm overflow-hidden">
        <CardHeader className="bg-gradient-to-r from-indigo-50 to-blue-50 border-b border-indigo-100 pb-4">
          <div className="flex items-center gap-2">
            <MessageSquare className="h-5 w-5 text-indigo-500" />
            <CardTitle className="text-lg font-semibold text-indigo-700">
              Call Transcript
            </CardTitle>
          </div>
        </CardHeader>
        <CardContent className="p-0">
          {callData.messages && callData.messages.length > 0 ? (
            <ScrollArea className="h-[500px] p-6">
              <div className="space-y-6">
                {callData.messages.map((message, index) => (
                  <div
                    key={index}
                    className={`flex gap-4 ${
                      message.role === "bot" ? "justify-start" : "justify-end"
                    }`}
                  >
                    {message.role === "bot" && (
                      <Avatar>
                        <AvatarFallback className="bg-indigo-100 text-indigo-700">
                          B
                        </AvatarFallback>
                      </Avatar>
                    )}
                    <div
                      className={`flex flex-col max-w-[75%] ${
                        message.role === "bot" ? "items-start" : "items-end"
                      }`}
                    >
                      <div
                        className={`px-4 py-3 rounded-lg ${
                          message.role === "bot"
                            ? "bg-indigo-50 text-gray-800 rounded-tl-none border border-indigo-100"
                            : "bg-indigo-600 text-white rounded-tr-none"
                        }`}
                      >
                        {message.message}
                      </div>
                      <div className="flex items-center gap-2 mt-1">
                        <span className="text-xs text-gray-500">
                          {formatMessageTime(message.time)}
                        </span>
                        <Badge
                          variant="outline"
                          className="text-xs bg-gray-50 border-gray-200 px-1"
                        >
                          {(message.duration / 1000).toFixed(1)}s
                        </Badge>
                      </div>
                    </div>
                    {message.role === "user" && (
                      <Avatar>
                        <AvatarFallback className="bg-indigo-600 text-white">
                          U
                        </AvatarFallback>
                      </Avatar>
                    )}
                  </div>
                ))}
              </div>
            </ScrollArea>
          ) : (
            <div className="flex flex-col items-center justify-center py-16">
              <MessageSquare className="h-12 w-12 text-gray-300 mb-4" />
              <h3 className="text-lg font-medium text-gray-700">
                No Transcript Available
              </h3>
              <p className="text-gray-500 mt-2">
                The transcript for this call is not available yet.
              </p>
            </div>
          )}
        </CardContent>
      </Card>
    </div>
  );
}