import { useNavigate } from "react-router-dom";
import { Row } from "@tanstack/react-table"
import { Button } from "@/components/ui/button";

interface DataTableRowActionsProps<TData> {
  row: Row<TData>
}

export function DataTableRowActions<TData>({
  row,
}: DataTableRowActionsProps<TData>) {
  const navigate = useNavigate();

  function onClickHandler() {
    navigate(`/call/${row.getValue("id")}`);
  }

  return <Button onClick={onClickHandler}>View</Button>
}
