export const humanizedTime = (duration: number, durationIn: 'hours' | 'minutes' | 'seconds' | 'milliseconds') => {
    let totalMilliseconds;
  
    if (durationIn === 'hours') {
      totalMilliseconds = duration * 3600000; // 1 hour = 3600000 milliseconds
    } else if (durationIn === 'minutes') {
      totalMilliseconds = duration * 60000; // 1 minute = 60000 milliseconds
    } else if (durationIn === 'seconds') {
      totalMilliseconds = duration * 1000; // 1 second = 1000 milliseconds
    } else {
      totalMilliseconds = duration;
    }
  
    const minutes = totalMilliseconds / 60000; 
    const hours = Math.floor(minutes / 60);
    const remainingMinutes = Math.floor(minutes % 60);
    const seconds = Math.round((minutes % 1) * 60);
  
    let timeString = '';
  
    if (hours > 0) {
      timeString += `${hours}h `;
    }
  
    if (remainingMinutes > 0 || hours > 0) {
      timeString += `${remainingMinutes}m `;
    }
  
    if (seconds > 0 || minutes % 1 !== 0) {
      timeString += `${seconds}s`;
    }
  
    if (!timeString) return '0s'
  
    return timeString.trim();
};
  